
<!DOCTYPE html>
<html lang="en">
<head>
  <meta charset="utf-8">
  <meta name="viewport" content="width=device-width, initial-scale=1.0">
  <title>Java多线程简析 / 憋错料</title>

    <meta name="description" content="Java多线程简析 一．线程的状态: 线程共有下面4种状态: 1.新建状态(New): 新创建了一个线程对象,当你用new创建一个线程时,该线程尚未运行. 2.就绪状态(Runnable): 线程对象创建后,其他线程调用了该对象的start()方法.该状态的线程位于可运行线程池中,变得可运行,等待获取CPU的使用权. 3.运行状态(Running): 就绪状态的线程获取了CPU,执行程序代码. 4.阻塞状态(Blocked): 阻塞状态是线程因为某种原因放弃CPU使用权,暂时停止运行.直到线程进入就绪状态,才有机会">
  

  <!-- <link rel="shortcut icon" href="/favicon.png"> -->  
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/bootstrap.css" rel="stylesheet">
  <link href="//pic.ikafan.com/staticx/biecuoliao/1/assets/css/style.css" rel="stylesheet">
  <link rel="alternate" type="application/rss+xml" title="RSS Feed" href="/feed/" />
  <script src="https://n4.ikafan.com/g/show.js"></script>
  <!-- HTML5 shim and Respond.js IE8 support of HTML5 elements and media queries -->
  <!--[if lt IE 9]>
  <script src="/assets/js/html5shiv.js"></script>
  <script src="/assets/js/respond.min.js"></script>
  <![endif]-->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?1438792cdde0845a4a8fe9d36e3569f8";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>

 
</head>

<body>

  <div class="wrapper">

    <header id="header" class="container">
    
      <div id="logo">
        <a href="/"><img src="//pic.ikafan.com/staticx/biecuoliao/1/assets/logo.png?2" title="" /></a>
      </div><!-- /logo -->

      <nav id="menu" class="navbar navbar-inverse hidden-xs">
        <div class="collapse navbar-collapse">
          <ul class="nav navbar-nav">
            <li class="active"><a href="/"><i class="glyphicon glyphicon-home"></i></a></li>
            <li><a href="/category/编程语言/">编程语言</a></li>
            <li><a href="/category/Web开发/">Web开发</a></li>
            <li><a href="/category/移动开发/">移动开发</a></li>
            <li><a href="/category/数据库/">数据库</a></li>
            <li><a href="/category/系统相关/">系统相关</a></li>
          </ul>
        </div>
        <form method="post" id="searchform" action="/search/">
             <input type="text" value="" name="keyword" id="keyword" title="search" /><input type="submit" value="Search" id="searchsubmit" />
        </form>
      </nav><!-- /nav -->

    </header>
    <!-- /header -->


    
    <div class="container">
      <div class="row">    


<div id="main" class="col-md-8">


<h1 class="mtitle">Java多线程简析</h1>
<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
    	<section>
		<article class="clearfix">
		<p><strong>一．线程的状态</strong>：</p>
<p>线程共有下面4种状态：</p>
<p><strong>1.新建状态（New）：</strong></p>
<p>新创建了一个线程对象，当你用new创建一个线程时，该线程尚未运行。</p>
<p><strong>2.就绪状态（Runnable）：</strong></p>
<p>线程对象创建后，其他线程调用了该对象的start（）方法。该状态的线程位于可运行线程池中，变得可运行，等待获取CPU的使用权。</p>
<p><strong>3.运行状态（Running）：</strong></p>
<p>就绪状态的线程获取了CPU，执行程序代码。</p>
<p><strong>4.阻塞状态（Blocked）：</strong></p>
<p>阻塞状态是线程因为某种原因放弃CPU使用权，暂时停止运行。直到线程进入就绪状态，才有机会转到运行状态。</p>
<p><strong>阻塞的情况分三种：</strong></p>
<p>a.&nbsp;等待阻塞：运行的线程执行wait（）方法，JVM会把该线程放入等待池中。</p>
<p>b.&nbsp;同步阻塞：运行的线程在获取对象的同步锁时，若该同步锁被别的线程占用，则JVM把该线程放入锁。</p>
<p>c.&nbsp;其他阻塞：运行的线程执行sleep（）或join（）方法，或者发出了I/O请求时，JVM会把该线程置为阻塞状态。当sleep（）状态超时、join（）等待线程终止或者超时、或者I/O处理完毕时，线程重新转入就绪状态。</p>
<p><strong>5.死亡状态（Dead）：</strong></p>
<p>a.&nbsp;由于run方法的正常退出而自然死亡;</p>
<p>b.&nbsp;没有捕获到的异常事件终止了run方法的执行，从而导致线程突然死亡</p>
<p><strong>如下图：</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MjgwNzIzMjI3Mjk/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p></strong></p>
<p><strong>线程的优先级：</strong></p>
<p>每一个<strong><a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer">Java</a></strong>线程都有一个优先级，这样有助于操作系统确定线程的调度顺序。</p>
<p><a href="http://lib.csdn.net/base/17" rel="external nofollow noreferrer"><strong>Java</strong></a>线程的优先级是一个整数，其取&#20540;范围是1（Thread.MIN_PRIORITY）&nbsp;- 10（Thread.MAX_PRIORITY）。</p>
<p>默认情况下，每一个线程都会分配一个优先级NORM_PRIORITY（5）。</p>
<p>具有较高优先级的线程对程序更重要，并且应该在低优先级的线程之前分配处理器资源。但是，线程优先级不能保证线程执行的顺序，而且非常依赖于平台。</p>
<p><strong>若要确定某个线程当前是否活着，可以使用&nbsp;isAlive方法。</strong></p>
<p>如果该线程是可运行线程或者被中断线程，那么该方法返回true；如果该线程仍然是个新建线程，或者该线程是个死线程，那么该方法返回false</p>
<p><strong>线程在不同情况下的状态变化。</strong></p>
<p><strong><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MjgwNzMxNDcwMDg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p></strong></p>
<p><strong>JAVA多线程实现方式：</strong></p>
<p>1、继承Thread类</p>
<p>2、实现Runnable接口</p>
<p>3、使用ExecutorService、Callable、Future实现有返回结果的多线程。</p>
<p>其中前两种方式线程执行完后都没有返回&#20540;，只有最后一种是带返回&#20540;的。其中最常用的也是前两种实现方式。</p>
<p><strong>Runnable和Thread实现多线程的区别：</strong></p>
<p><strong>Runnable接口相比继承Thread类有如下优势：</strong></p>
<p>1、可以避免由于Java的单继承特性而带来的局限；</p>
<p>2、增强程序的健壮性，代码能够被多个线程共享，代码与数据是独立的；</p>
<p>3、适合多个相同程序代码的线程区处理同一资源的情况。</p>
<p><strong>下面以典型的买票程序（基本都是以这个为例子）为例，来说明二者的区别。</strong></p>
<p><strong></strong></p>
<pre>&lt;code class=&quot;hljs axapta has-numbering&quot; style=&quot;display: block; padding: 0px; color: inherit; box-sizing: border-box; font-family: &#039;Source Code Pro&#039;, monospace;font-size:undefined; white-space: pre; border-radius: 0px; word-wrap: normal; background: transparent;&quot;&gt;&lt;span class=&quot;hljs-class&quot; style=&quot;box-sizing: border-box;&quot;&gt;&lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;class&lt;/span&gt; &lt;span class=&quot;hljs-title&quot; style=&quot;box-sizing: border-box; color: rgb(102, 0, 102);&quot;&gt;MyThread&lt;/span&gt; &lt;span class=&quot;hljs-inheritance&quot; style=&quot;box-sizing: border-box;&quot;&gt;&lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;extends&lt;/span&gt;&lt;/span&gt; &lt;span class=&quot;hljs-title&quot; style=&quot;box-sizing: border-box; color: rgb(102, 0, 102);&quot;&gt;Thread&lt;/span&gt;{&lt;/span&gt; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;private&lt;/span&gt; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;int&lt;/span&gt; ticket = &lt;span class=&quot;hljs-number&quot; style=&quot;color: rgb(0, 102, 102); box-sizing: border-box;&quot;&gt;5&lt;/span&gt;; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;public&lt;/span&gt; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;void&lt;/span&gt; run(){ &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;for&lt;/span&gt; (&lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;int&lt;/span&gt; i=&lt;span class=&quot;hljs-number&quot; style=&quot;color: rgb(0, 102, 102); box-sizing: border-box;&quot;&gt;0&lt;/span&gt;;i&lt;&lt;span class=&quot;hljs-number&quot; style=&quot;color: rgb(0, 102, 102); box-sizing: border-box;&quot;&gt;10&lt;/span&gt;;i++) { &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;if&lt;/span&gt;(ticket &gt; &lt;span class=&quot;hljs-number&quot; style=&quot;color: rgb(0, 102, 102); box-sizing: border-box;&quot;&gt;0&lt;/span&gt;){ System.out.println(&lt;span class=&quot;hljs-string&quot; style=&quot;color: rgb(0, 136, 0); box-sizing: border-box;&quot;&gt;&quot;ticket = &quot;&lt;/span&gt; + ticket--); } } } } &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;public&lt;/span&gt; &lt;span class=&quot;hljs-class&quot; style=&quot;box-sizing: border-box;&quot;&gt;&lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;class&lt;/span&gt; &lt;span class=&quot;hljs-title&quot; style=&quot;box-sizing: border-box; color: rgb(102, 0, 102);&quot;&gt;ThreadDemo&lt;/span&gt;{&lt;/span&gt; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;public&lt;/span&gt; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;static&lt;/span&gt; &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;void&lt;/span&gt; main(String[] args){ &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;new&lt;/span&gt; MyThread().start(); &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;new&lt;/span&gt; MyThread().start(); &lt;span class=&quot;hljs-keyword&quot; style=&quot;color: rgb(0, 0, 136); box-sizing: border-box;&quot;&gt;new&lt;/span&gt; MyThread().start(); } &lt;/code&gt;&lt;ul class=&quot;pre-numbering&quot; style=&quot;box-sizing: border-box; position: absolute; width: 50px; top: 0px; left: 0px; margin: 0px; padding: 6px 0px 40px; border-right-width: 1px; border-right-style: solid; border-right-color: rgb(221, 221, 221); list-style: none; text-align: right; background-color: rgb(238, 238, 238);&quot;&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;1&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;2&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;3&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;4&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;5&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;6&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;7&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;8&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;9&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;10&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;11&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;12&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;13&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;14&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;15&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;16&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;17&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;18&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;19&lt;/li&gt;&lt;/ul&gt;&lt;ul class=&quot;pre-numbering&quot; style=&quot;box-sizing: border-box; position: absolute; width: 50px; top: 0px; left: 0px; margin: 0px; padding: 6px 0px 40px; border-right-width: 1px; border-right-style: solid; border-right-color: rgb(221, 221, 221); list-style: none; text-align: right; background-color: rgb(238, 238, 238);&quot;&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;1&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;2&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;3&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;4&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;5&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;6&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;7&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;8&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;9&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;10&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;11&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;12&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;13&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;14&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;15&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;16&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;17&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;18&lt;/li&gt;&lt;li style=&quot;box-sizing: border-box; padding: 0px 5px;&quot;&gt;19&lt;/li&gt;&lt;/ul&gt;  </pre>
<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MjgwNzMyMDEyNTg/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>从结果中可以看出，每个线程单独卖了5张票，即独立地完成了买票的任务，但实际应用中，比如火车站售票，需要多个线程去共同完成任务，在本例中，即多个线程共同买5张票。</p>
<p><strong>下面是通过实现Runnable接口实现的多线程程序，代码如下：</strong></p>
<p><strong>[java]</strong>&nbsp;<a href="http://blog.csdn.net/fanyun_01/article/details/51523194#" rel="external nofollow noreferrer">view<br />
 plain</a>&nbsp;<a href="http://blog.csdn.net/fanyun_01/article/details/51523194#" rel="external nofollow noreferrer">copy</a></p>
<p><a href="http://blog.csdn.net/fanyun_01/article/details/51523194#" rel="external nofollow noreferrer">print</a><a href="http://blog.csdn.net/fanyun_01/article/details/51523194#" rel="external nofollow noreferrer">?</a><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL0NPREVfaWNvLnBuZw==.jpg"><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHBzL2NvZGUuY3Nkbi5uZXQvYXNzZXRzL2ljb19mb3JrLnN2Zw==.jpg"></p>
<ol>
<li>&lt;code&nbsp;class=&quot;hljs&nbsp;axapta&nbsp;has-numbering&quot;&nbsp;style=&quot;display:&nbsp;block;&nbsp;padding:&nbsp;0px;&nbsp;color:&nbsp;inherit;&nbsp;box-sizing:&nbsp;border-box;&nbsp;font-family:&nbsp;‘Source&nbsp;Code&nbsp;Pro‘,&nbsp;monospace;font-size:undefined;&nbsp;white-space:&nbsp;pre;&nbsp;border-radius:&nbsp;0px;&nbsp;word-wrap:&nbsp;normal;&nbsp;background:&nbsp;transparent;&quot;&gt;&lt;span&nbsp;class=&quot;hljs-class&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&quot;&gt;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;class&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-title&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;color:&nbsp;rgb(102,&nbsp;0,&nbsp;102);&quot;&gt;MyThread&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-inheritance&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&quot;&gt;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;implements&lt;/span&gt;&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-title&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;color:&nbsp;rgb(102,&nbsp;0,&nbsp;102);&quot;&gt;Runnable&lt;/span&gt;{&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;private&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;int&lt;/span&gt;&nbsp;ticket&nbsp;=&nbsp;&lt;span&nbsp;class=&quot;hljs-number&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;102,&nbsp;102);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;5&lt;/span&gt;;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;public&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;void&lt;/span&gt;&nbsp;run(){&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;for&lt;/span&gt;&nbsp;(&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;int&lt;/span&gt;&nbsp;i=&lt;span&nbsp;class=&quot;hljs-number&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;102,&nbsp;102);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;0&lt;/span&gt;;i&lt;&lt;span&nbsp;class=&quot;hljs-number&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;102,&nbsp;102);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;10&lt;/span&gt;;i&#043;&#043;)&nbsp;{&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;if&lt;/span&gt;(ticket&nbsp;&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-number&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;102,&nbsp;102);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;0&lt;/span&gt;){&nbsp;System.out.println(&lt;span&nbsp;class=&quot;hljs-string&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;136,&nbsp;0);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;&quot;ticket&nbsp;=&nbsp;&quot;&lt;/span&gt;&nbsp;&#043;&nbsp;ticket--);&nbsp;}&nbsp;}&nbsp;}&nbsp;}&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;public&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-class&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&quot;&gt;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;class&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-title&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;color:&nbsp;rgb(102,&nbsp;0,&nbsp;102);&quot;&gt;RunnableDemo&lt;/span&gt;{&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;public&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;static&lt;/span&gt;&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;void&lt;/span&gt;&nbsp;main(String[]&nbsp;args){&nbsp;MyThread&nbsp;my&nbsp;=&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;new&lt;/span&gt;&nbsp;MyThread();&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;new&lt;/span&gt;&nbsp;Thread(my).start();&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;new&lt;/span&gt;&nbsp;Thread(my).start();&nbsp;&lt;span&nbsp;class=&quot;hljs-keyword&quot;&nbsp;style=&quot;color:&nbsp;rgb(0,&nbsp;0,&nbsp;136);&nbsp;box-sizing:&nbsp;border-box;&quot;&gt;new&lt;/span&gt;&nbsp;Thread(my).start();&nbsp;}&nbsp;}&nbsp;&lt;/code&gt;&lt;ul&nbsp;class=&quot;pre-numbering&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;position:&nbsp;absolute;&nbsp;width:&nbsp;50px;&nbsp;top:&nbsp;0px;&nbsp;left:&nbsp;0px;&nbsp;margin:&nbsp;0px;&nbsp;padding:&nbsp;6px&nbsp;0px&nbsp;40px;&nbsp;border-right-width:&nbsp;1px;&nbsp;border-right-style:&nbsp;solid;&nbsp;border-right-color:&nbsp;rgb(221,&nbsp;221,&nbsp;221);&nbsp;list-style:&nbsp;none;&nbsp;text-align:&nbsp;right;&nbsp;background-color:&nbsp;rgb(238,&nbsp;238,&nbsp;238);&quot;&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;1&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;2&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;3&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;4&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;5&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;6&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;7&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;8&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;9&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;10&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;11&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;12&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;13&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;14&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;15&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;16&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;17&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;18&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;19&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;20&lt;/li&gt;&lt;/ul&gt;&lt;ul&nbsp;class=&quot;pre-numbering&quot;&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;position:&nbsp;absolute;&nbsp;width:&nbsp;50px;&nbsp;top:&nbsp;0px;&nbsp;left:&nbsp;0px;&nbsp;margin:&nbsp;0px;&nbsp;padding:&nbsp;6px&nbsp;0px&nbsp;40px;&nbsp;border-right-width:&nbsp;1px;&nbsp;border-right-style:&nbsp;solid;&nbsp;border-right-color:&nbsp;rgb(221,&nbsp;221,&nbsp;221);&nbsp;list-style:&nbsp;none;&nbsp;text-align:&nbsp;right;&nbsp;background-color:&nbsp;rgb(238,&nbsp;238,&nbsp;238);&quot;&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;1&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;2&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;3&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;4&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;5&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;6&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;7&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;8&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;9&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;10&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;11&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;12&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;13&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;14&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;15&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;16&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;17&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;18&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;19&lt;/li&gt;&lt;li&nbsp;style=&quot;box-sizing:&nbsp;border-box;&nbsp;padding:&nbsp;0px&nbsp;5px;&quot;&gt;20&lt;/li&gt;&lt;/ul&gt;</li>
</ol>

<p><img src="//pic.ikafan.com/imgp/L3Byb3h5L2h0dHAvaW1nLmJsb2cuY3Nkbi5uZXQvMjAxNjA1MjgwNzMzMDc2OTc/d2F0ZXJtYXJrLzIvdGV4dC9hSFIwY0RvdkwySnNiMmN1WTNOa2JpNXVaWFF2L2ZvbnQvNWE2TDVMMlQvZm9udHNpemUvNDAwL2ZpbGwvSTBKQlFrRkNNQT09L2Rpc3NvbHZlLzcwL2dyYXZpdHkvQ2VudGVy.jpg"></p>
<p>从结果中可以看出，三个线程一共卖了5张票，即它们共同完成了买票的任务，实现了资源的共享。</p>
<p><strong>区别总结：</strong></p>
<p>1、在第二种方法（Runnable）中，ticket输出的顺序并不是54321，这是因为线程执行的时机难以预测，ticket–并不是原子操作。</p>
<p>2、在第一种方法中，我们new了3个Thread对象，即三个线程分别执行三个对象中的代码，因此便是三个线程去独立地完成卖票的任务；而在第二种方法中，我们同样也new了3个Thread对象，但只有一个Runnable对象，3个Thread对象共享这个Runnable对象中的代码，因此，便会出现3个线程共同完成卖票任务的结果。如果我们new出3个Runnable对象，作为参数分别传入3个Thread对象中，那么3个线程便会独立执行各自Runnable对象中的代码，即3个线程各自卖5张票。</p>
<p>3、在第二种方法中，由于3个Thread对象共同执行一个Runnable对象中的代码，因此可能会造成线程的不安全，比如可能ticket会输出-1（如果我们System.out….语句前加上线程休眠操作，该情况将很有可能出现），这种情况的出现是由于，一个线程在判断ticket为1&gt;0后，还没有来得及减1，另一个线程已经将ticket减1，变为了0，那么接下来之前的线程再将ticket减1，便得到了-1。这就需要加入同步操作（即互斥锁），确保同一时刻只有一个线程在执行每次for循环中的操作。而在第一种方法中，并不需要加入同步操作，因为每个线程执行自己Thread对象中的代码，不存在多个线程共同执行同一个方法的情况。</p>
<p><strong>介绍完以上几个实例，我们下面对sleep（）、wait（）、yeid（）、join（）几个方法进行下区别总结</strong></p>
<p><strong>sleep方法与wait方法的区别：</strong></p>
<p>1.sleep方法是静态方法，wait方法是非静态方法。</p>
<p>2.sleep方法在时间到后会自己“醒来”，但wait不能，必须由其它线程通过notify（All）方法让它“醒来”。</p>
<p>3.sleep方法通常用在不需要等待资源情况下的阻塞，像等待线程、<strong><a href="http://lib.csdn.net/base/14" rel="external nofollow noreferrer">数据库</a></strong>连接的情况一般用wait。</p>
<p><strong>sleep/wait与yeld方法的区别：</strong></p>
<p>调用sleep或wait方法后，线程即进入block状态，而调用yeld方法后，线程进入runnable状态。</p>
<p><strong>wait与join方法的区别：</strong></p>
<p>1.wait方法体现了线程之间的互斥关系，而join方法体现了线程之间的同步关系。</p>
<p>2.wait方法必须由其它线程来解锁，而join方法不需要，只要被等待线程执行完毕，当前线程自动变为就绪。</p>
<p>3.join方法的一个用途就是让子线程在完成业务逻辑执行之前，主线程一直等待直到所有子线程执行完毕。</p>				<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
				<div id="time"><strong>时间：</strong> 2024-02-28 01:22:49 </div>
		</article>

		<!-- social network share -->

<!-- 		<div id="tags">
            <strong>Tags:</strong>         </div> -->
	</section>
	
	

		<div id="similar" class="row">

		<h3>Java多线程简析的相关文章</h3>

								<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MLqNNy0.html" rel="bookmark">JAVA泛型简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				泛型是JDK1.5支持的新功能之一,在目前的JAVA编程中被广泛的使用,下面我们就来看看泛型和它的属性. 1.Java泛型 其实Java的泛型就是创建一个用类型作为参数的类.就象我们写类的方法一样,方法是这样的method(String str1,String str2 ),方法中参数str1.str2的值是可变的.而泛型也是一样的,这样写class Java_Generics&lt;K,V&gt;,这里边的K和V就象方法中的参数str1和str2,也是可变.下面看看例子: //code list 1 i			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MEvYp10.html" rel="bookmark">Java CAS简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				什么是CAS CAS:Compare and Swap,它是一种原子操作,什么是原子操作,可以在多线程编程中实现数据交换而不被打断.是用来更新变量的,当多个线程使用CAS来更新变量时,只有一个线程可以更新变量的值,其他线程都会失败,失败的线程不回被挂起,而是重试直到成功为止. CAS实现方式,有三个变量,内存值V,处理器缓存(预期值)A,更新值B.比较内存值与预期值,相等则说明没有其他线程操作共享数据,则更新内存值为B:不等说明共享数据V已经被其他线程改动了,放弃更新操作,重新load共享数据,			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/E3wBwQ0.html" rel="bookmark">JDK源码简析--java&period;lang包中的基础类库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题记 JDK,Java Development Kit. 我们必须先认识到,JDK只是,仅仅是一套Java基础类库而已,是Sun公司开发的基础类库,仅此而已,JDK本身和我们自行书写总结的类库,从技术含量来说,还是在一个层级上,它们都是需要被编译成字节码,在JRE中运行的,JDK编译后的结果就是jre/lib下得rt.jar,我们学习使用它的目的是加深对Java的理解,提高我们的Java编码水平. 本系列所有文章基于的JDK版本都是1.7.16. 本节内容 在本节中,简析java.lang包所包			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MmYYjQM.html" rel="bookmark">JDK框架简析--java&period;lang包中的基础类库、基础数据类型</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题记 JDK.Java Development Kit. 我们必须先认识到,JDK不过,不过一套Java基础类库而已,是Sun公司开发的基础类库,仅此而已,JDK本身和我们自行书写总结的类库,从技术含量来说.还是在一个层级上,它们都是须要被编译成字节码.在JRE中执行的,JDK编译后的结果就是jre/lib下的rt.jar,我们学习使用它的目的是加深对Java的理解,提高我们的Java编码水平. 本系列全部文章基于的JDK版本号都是1.7.16. 源代码下载地址:https://jdk7.jav			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/4APZPK3.html" rel="bookmark">Java Annotation 及几个常用开源项目注解原理简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				PDF 版: Java Annotation.pdf, PPT 版:Java Annotation.pptx, Keynote 版:Java Annotation.key 一.Annotation 示例 Override Annotation Java 1 2 3 @Override public void onCreate(Bundle savedInstanceState); Retrofit Annotation Java 1 2 3 @GET(&quot;/users/{username}&quo			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MgPdQn0.html" rel="bookmark">&lbrack;转载&rsqb; Thrift原理简析&lpar;JAVA&rpar;</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				转载自http://shift-alt-ctrl.iteye.com/blog/1987416 Apache Thrift是一个跨语言的服务框架,本质上为RPC,同时具有序列化.发序列化机制:当我们开发的service需要开放出去的时候,就会遇到跨语言调用的问题,JAVA语言开发了一个UserService用来提供获取用户信息的服务,如果服务消费端有PHP/Python/C++等,我们不可能为所有的语言都适配出相应的调用方式,有时候我们会很无奈的使用Http来作为访问协议;但是如果服务消费端不能			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MzEYvk4.html" rel="bookmark">Java Android 注解&lpar;Annotation&rpar; 及几个常用开源项目注解原理简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				不少开源库(ButterKnife.Retrofit.ActiveAndroid等等)都用到了注解的方式来简化代码提高开发效率. 本文简单介绍下 Annotation 示例.概念及作用.分类.自定义.解析,并对几个 Android 开源库 Annotation 原理进行简析.PDF 版: Java Annotation.pdf, PPT 版:Java Annotation.pptx, Keynote 版:Java Annotation.key 完整版原文见:Java Android 注解(Ann			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/MDk2O74.html" rel="bookmark">JDK源码简析--java&period;util包中的工具类库</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				题记 JDK,Java Development Kit. 我们必须先认识到,JDK只是,仅仅是一套Java基础类库而已,是Sun公司开发的基础类库,仅此而已,JDK本身和我们自行书写总结的类库,从技术含量来说,还是在一个层级上,它们都是需要被编译成字节码,在JRE中运行的,JDK编译后的结果就是jre/lib下得rt.jar,我们学习使用它的目的是加深对Java的理解,提高我们的Java编码水平. 本系列所有文章基于的JDK版本都是1.7.16. 本节内容 在本节中,简析java.util包所包			</div>
		</article>
	</section>
				<section>
		<header>
			<h2 class="title">
                <a href="https://www.biecuoliao.com/pa/r4JkrbM.html" rel="bookmark">web应用构架LAMT及tomcat负载简析</a>
			</h2>
		</header>
		<article class="clearfix">
									<div class="summary">
				Httpd    (mod_jk.so) workers.properties文件 uriworkermap.properties文件 &lt;--AJP1.3--&gt; Tomcat  --&gt; jdk 大致流程:apache服务器通过mod_jk.so 模块处理jsp文件的动态请求.通过tomcat worker等待执行servlet/JSP的tomcat实例.使用 AJP1.3协议与tomcat通信.tomcat有借助jdk解析. 负载就是 多台tomcat.共同解析apache发送的jsp请			</div>
		</article>
	</section>
	
	</div><!-- /related -->
	


</div>
<!-- /main -->


<aside class="col-md-4">



	<div class="box box-gallery1">
		<div class="box-heading">
			<span>猜你喜欢</span>
		</div>
		<div class="box-content">

									<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/XMgrxB4.html" rel="bookmark" class="title">LeetCode Problem 3&period;Longest Substring Without Repeating Characters</a>
					<div>
						Given a string, find the length of the longest substring without repeating characters. Examples: Giv ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/4JkWkPM.html" rel="bookmark" class="title">TCP&sol;IP详解之一：连接建立、断开</a>
					<div>
						&lt;TCP/IP详解·卷一&gt;看了三遍才算整明白个大概,一直想做个总结. 最初对TCP的印象很简单:丢包重传.流数据.丢包重传很好理解,“流数据”是什么鬼? 知乎上看到个极好的解释:把TCP看 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0j5dO7M.html" rel="bookmark" class="title">（Android Studio）简单实现：双击返回键，退出应用首页</a>
					<div>
						设计需求:当用户想要退出某个页面(经常为首页)时,跳出Toast提示信息“再按返回键退出!”. 当用户两次双击,时间间隔少于800毫秒时,退出该应用.否则只显示提示信息,无操作. @Override  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3wvOnN0.html" rel="bookmark" class="title">进入Python世界&mdash;&mdash;Python学习系列之一</a>
					<div>
						安装Python window下载安装Python python官网地址:https://www.python.org/ 进入官网下载python客户端,现最新的python是python3.5.因p ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MLWD7Q4.html" rel="bookmark" class="title">C语言中使用系统自带的快排函数</a>
					<div>
						题目 1015. 德才论 (25) 宋代史学家司马光在&lt;资治通鉴&gt;中有一段著名的&quot;德才论&quot;:&quot;是故才德全尽谓之圣人,才德兼亡谓之愚人,德胜才谓之君子,才胜德谓 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MXQDPG0.html" rel="bookmark" class="title">猩茉睦闲柿ec7zs9t3icld</a>
					<div>
						刘尘远毫无办法,要搁在以前,董璃发病的时候,他也就打点杜冷丁之类的止痛药而已.可现在别说是止痛药了,他甚至已经给董璃打了麻醉剂,都不见任何好转.&quot;等等!&quot;现在杜晨奇怪的就是,他通过 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBaRdj4.html" rel="bookmark" class="title">HDU - 4028 The time of a day&lpar;离散&plus;DP&rpar;</a>
					<div>
						Description There are no days and nights on byte island, so the residents here can hardly determine  ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MylDen4.html" rel="bookmark" class="title">Windows内核之线程的调度，优先级，亲缘性</a>
					<div>
						1 调度 Windows不是实时操作系统,它是抢占式多线程操作系统.在假设所有优先级相同的情况下,CPU对线程的调度原则是每隔20m就会切换到下一个线程,根据Context中的IP和SP来接着执行上次 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0YRyRO3.html" rel="bookmark" class="title">Bootstrap幻灯片</a>
					<div>
						Bootstrap幻灯片的制作利用到了Carousel插件,包含:左右箭头.图片.点点导航 &lt;div id=&quot;carousel-example-generic&quot; class= ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MzAbJO4.html" rel="bookmark" class="title">2&period;2linux内核移植简介</a>
					<div>
						1,编译linux3.5出错 [email protected]:/opt/FriendlyARM/tiny4412/Linux/linux-3.5# makescripts/kconfig/conf ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38bQo1M.html" rel="bookmark" class="title">8&period;js模式-状态模式</a>
					<div>
						1. 状态模式 var offLightState = function(light){ this.light = light; } offLightState.prototype.buttonWas ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/02yqNnM.html" rel="bookmark" class="title">通过phpise命令编译php扩展程序</a>
					<div>
						由于我的php环境已经安装完毕.但是我的应用程序需要zlib扩展.(注,我的php是通过make编译的.)以下是操作步骤: 1. 在php的编译目录下,$php_source/ext/zlib目录中, ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/3rBOL73.html" rel="bookmark" class="title">R语言笔记 数学函数</a>
					<div>
						数学函数 表5-2列出了常用的数学函数和简短的用例. 表5-2 数学函数 函 数 描 述 abs(x) 绝对值 abs(-4)返回值为4 sqrt(x) 平方根sqrt(25)返回值为5 和25^(0 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RmvljM.html" rel="bookmark" class="title">大型网站系统架构的演进（二）分布式模块之间的通信</a>
					<div>
						上一篇文章中讲到了分布式部署之后,各个模块要通过网络进行通信,那么如何通信,用什么协议呢? 可选的方案有http tcp/ip(socket)等 http短连接通信方案 基于http协议,xml报文传 ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MPejxv0.html" rel="bookmark" class="title">Leetcode题解（二）</a>
					<div>
						4.Median of Two Sorted Arrays 题目 题目要求找到两个排序数组的中位数. 中位数的定义:当n为奇数时,median = array[n/2];当n为偶数时,median = ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0RjKlY0.html" rel="bookmark" class="title">centos 安装 lnmp</a>
					<div>
						直接yum install nginx不行,要先处理下源,下面是安装完整流程 1. rpm -ivh http://nginx.org/packages/centos/6/noarch/RPMS/ng ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/38rVBRM.html" rel="bookmark" class="title">poj 3378 crazy thairs</a>
					<div>
						题目大意: 一个数列,求i,j,k,l,m满足: 1 ≤ i &lt; j &lt; k &lt; l &lt; m ≤ N  且 Ai &lt; Aj &lt; Ak &lt; Al &lt; Am ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MBnxdKM.html" rel="bookmark" class="title">嵌入式系统通讯协议</a>
					<div>
						#######I2C####### I2C is a two wire protocol used to connect one or more &quot;masters&quot; with on ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/MENV6Q0.html" rel="bookmark" class="title">多个有序链表的合并</a>
					<div>
						1, 先将问题简化,合并两个有序链表 首先分析合并两个链表的过程.我们的分析从合并两个链表的头结点开始.链表1的头结点的值小于链表2的头结点的值,因此链表1的头结点将是合并后链表的头结点.如下图所示. ...					</div>
				</div>
			</div>
						<div class="item clearfix">
										<div class="info"  style="max-width: 100%;" >
					<a href="https://www.biecuoliao.com/pa/0agrzg4.html" rel="bookmark" class="title">freemarker写select组件（五）</a>
					<div>
						freemarker写select组件 1.宏定义 &lt;#macro select id datas value=&quot;&quot; key=&quot;&quot; text=&quot; ...					</div>
				</div>
			</div>
			
		</div>
	</div>

	<div class="box">
		<div class="box-heading">
			<span>专题</span>
		</div>
		<div class="box-content">
					</div>
	</div>

	<div class="box box-gallery3">
		<div class="box-heading">
			<span>随机推荐</span>
		</div>
		<div class="box-content clearfix">


		</div>
	</div>

</aside>
      </div>
    </div>
    <!-- /.container -->

    <div id="copyright">
      <div class="pull-left">
        &#169; 2024 憋错料        | info#biecuoliao.com        | 10 q. 0.029 s.
      </div>

    </div>

  </div><!--/.wrapper -->


  <div style=" display: none ";>
  </div>


</body>
</html>
